/***************************************************************************
 *   Copyright (C) 2005 by Peter Müller   *
 *   pmueller@cs.tu-berlin.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EXPLOSION_H
#define EXPLOSION_H

#include "effect.h"
#include "decal.h"
#include "particlesystem.h"


/**
@author Peter Müller
*/


class Explosion : public Effect
{
public:
	Explosion(GLuint decal_tex, GLuint particle_texture, 
			  const Vec4& start_color, const Vec4& end_color,
	          const Vec3& p, const Vec3 & normal, float size, bool _decal, 
	          float time);
    ~Explosion();
	
	virtual void process(float time);
	virtual void render(const Vec3& campos);
	virtual void stop();
	virtual bool done();
	
	virtual void setPos(const Vec3 & _pos);

private:
	Decal *decal;
	ParticleSystem *psystem;
}; 

#endif
